;
;****************************************************************************
;****************************************************************************
;****************************************************************************
;***                                                                      ***
;***	       THE MISADVENTURES OF B.O.B. IN FERNANDO 3C LAND		  ***
;***                                                                      ***
;*** 		Copyright 1998-1999 by Pelissier Patrick		  ***
;***                                                                      ***
;****************************************************************************
;****************************************************************************
;****************************************************************************
;

; Current release : 0.15

 include "TIOS.h"
 include "Flib.h"
 include "Pk92lib.h"
 include "Hexlib.h"
 include "fer3c.h"

;
;****************************************************************************
;***                                                                      ***
;***            		Choose your O.S.		  	  ***
;***                                                                      ***
;****************************************************************************

; include "FargoII.h"
; include "Plus92.h"
 include "H89.h"
 
 include "Bob.h"
 include "EnmBob.h"


; You need it to restore the sprite.
NUMBER		EQU	78	; Nbr of the sprite in Level-File
INIT_ADDON	EQU	112	; Nbr to pass to spriteinit
				; to init an addon. Example :
				; moveq	#INIT_ADDON,d0
				; ...d1 ... d2 ... d3
				; jsr	fer3c::SpriteInit

MAX_SPRITE	EQU	9

SpriteInit:
 move.l	fer3c::LevelADR,a2
 moveq	#0,d4
 move.b 0(a2,d3.w),d4
 move.w	d4,d5
 cmp.w	#MAX_SPRITE,d5
 blt.s	\Ok
 rts
\Ok:
 add.w	d5,d5
 clr.b	0(a2,d3.w)
 move.w	#4000,fer3c::Ys-4	; YsOld : Refresh virtual screen
 move.w	Sprite_Init_Code_Table(pc,d5.w),d5
 jmp	Sprite_Init_Code_Table(pc,d5.w)

Sprite_Init_Code_Table
	dc.w	Sprite_Init_Bob-Sprite_Init_Code_Table		; 0
	dc.w	Sprite_Init_L_Head-Sprite_Init_Code_Table	; 1
	dc.w	Sprite_Init_Thief-Sprite_Init_Code_Table	; 2
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 3
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 4
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 5
	dc.w	Sprite_Init_Missile-Sprite_Init_Code_Table	; 6
	dc.w	Sprite_Init_Point-Sprite_Init_Code_Table	; 7
	dc.w	Sprite_Init_Hedg-Sprite_Init_Code_Table		; 8

Sprite_Init_Bob:
 move.l	fer3c::SpriteADR,a0
 move.w d0,No(a0)
 clr.w	No2(a0)
 move.w	#100,F_Haut(a0)
 move.w	fer3c::Turbo,d0
 add.w	d0,d0
 move.w	d0,MyTurbo
 rts			; Exit

Sprite_Init_L_Head:
 lea	-L_End(a0),a0	; Sprite Max Buffer - size of the sprite
 cmp.l	a0,a1		; Is there enought free memory in sprite buffer ?
 bhi.s	Skip1		; No exit
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#2,No2(a1)	; Sub sprite No 1 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 move.w	#LITTLE_HEAD,Dessin(a1)
 move.w	fer3c::Turbo,L_Vx(a1)	; We will go to the right : SpeedX = 1
 move.w	#80,L_Wait(a1)
 lea	L_End(a1),a1	; New SpriteEndADR
Skip1:
 rts			; Exit

Sprite_Init_Thief:
 lea	-T_End(a0),a0	; Sprite Max Buffer - size of the sprite
 cmp.l	a0,a1		; Is there enought free memory in sprite buffer ?
 bhi.s	Skip2		; No exit
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#4,No2(a1)	; Sub sprite No 2 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 move.w	#THIEF,Dessin(a1)
 move.w	fer3c::Turbo,T_Vx(a1)	; We will go to the right : SpeedX = 1
 move.w	fer3c::Turbo,T_Vy(a1)
 clr.w	T_Wait(a1)
 lea T_End(a1),a1	; New SpriteEndADR
Skip2:
 rts			; Exit

Sprite_Init_Missile:
 lea	-M_End(a0),a0	; Sprite Max Buffer - size of the sprite
 cmp.l	a0,a1		; Is there enought free memory in sprite buffer ?
 bhi.s	\Skip		; No exit
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#6,No2(a1)	; Sub sprite No 3 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 lea M_End(a1),a1	; New SpriteEndADR
\Skip:
 rts			; Exit

Sprite_Init_Point:
 lea	-(4*P_End)(a0),a0	; Sprite Max Buffer - size of the sprite
 cmp.l	a0,a1		; Is there enought free memory in sprite buffer ?
 bhi.s	\Skip		; No exit
 move.w	#1,P_Vx(a1)
 move.w	#1,P_Vy(a1)
 bsr	Sub_1_Init_Point
 move.w	#1,P_Vx(a1)
 move.w	#-1,P_Vy(a1)
 bsr	Sub_1_Init_Point
 move.w	#-1,P_Vx(a1)
 move.w	#1,P_Vy(a1)
 bsr	Sub_1_Init_Point
 move.w	#-1,P_Vx(a1)
 move.w	#-1,P_Vy(a1)
 bsr	Sub_1_Init_Point
\Skip:
 rts			; Exit

Sub_1_Init_Point:
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#8,No2(a1)	; Sub sprite No 4 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 lea P_End(a1),a1	; New SpriteEndADR
 rts

Sprite_Init_Hedg:
 lea	-H_End(a0),a0	; Sprite Max Buffer - size of the sprite
 cmp.l	a0,a1		; Is there enought free memory in sprite buffer ?
 bhi.s	\Skip2		; No exit
 move.w d0,No(a1)	; No of Sprite AddOn : YOU MUST NO CHANGE THIS !
 move.w d1,Xj(a1)	; Start X of the sprite
 move.w d2,Yj(a1)	; Start Y of the sprite
 move.w	#10,No2(a1)	; Sub sprite No 5 (*2) 
 move.w d3,Adress(a1)	; Adress in the table of the starting-point of the sprite
 move.w	d4,Gfx(a1)	; Gfx in LevelGfxTable whan call
 move.w	fer3c::Turbo,H_Vx(a1)	; We will go to the right : SpeedX = 1
 move.w	#20,H_WAct(a1)
 clr.w	H_Act(a1)
 move.w	#30,H_Wait(a1)
 clr.w	H_Fire(a1)
 move.w	#30,H_Invu(a1)
 clr.w	H_A(a1)
 lea	H_End(a1),a1	; New SpriteEndADR
\Skip2:
 rts			; Exit







SpriteExec:
 move.w	No2(a5),d0	; Get the type of the sprite
 move.w	Sprite_Code_Table(pc,d0.w),d0     
 jmp	Sprite_Code_Table(pc,d0.w)

Sprite_Code_Table:
	dc.w	Sprite_Bob-Sprite_Code_Table
	dc.w	Sprite_L_Head-Sprite_Code_Table
	dc.w	Sprite_Thief-Sprite_Code_Table
	dc.w	Sprite_Missile-Sprite_Code_Table
	dc.w	Sprite_Point-Sprite_Code_Table
	dc.w	Sprite_Hedg-Sprite_Code_Table

Sprite_Bob:
 move.w Xj(a5),d6
 move.w Yj(a5),d7

 move.w	MyTurbo(PC),F_Speed(a5)

 move.b fer3c::KeyStat,d5
 move.w d6,d0
 move.w d7,d1

; Left ?
 btst.b #Left_Key,d5
 bne.s  NoLeft

 move.w #1,F_Sens(a5)
 sub.w  F_Speed(a5),d0
 jsr    fer3c::GetTest
 beq.s  SuiteAct
 move.w d0,d6
 bra.s	SuiteAct

; Right ?
NoLeft: 
 btst.b #Right_Key,d5
 bne.s  SuiteAct
 clr.w  F_Sens(a5)
 add.w  F_Speed(a5),d0
 jsr    fer3c::GetTest
 beq.s  SuiteAct
 move.w d0,d6
SuiteAct:

; Test sortie Gauche/Droite
 cmpi.w #4080,d0	; 32 * tailleX - TaillXBob
 bls.s	Suitegd0
 clr.w  F_Mx(a5)
 clr.w  d6
 cmpi.w #10000,d0
 bhi.s	Suitegd0
 move.w #4080,d6
Suitegd0:

 Boule_Key_Test
 bne.s	\NoBoule
 cmp.w	#BOUBOULE_MAX,BouBoule
 bne.s	\NoBoule
 clr.l	F_Mx(a5)
 move.w	fer3c::Turbo,d0
 lsl.w	#2,d0
 btst.w	#Left_Key,d5
 bne.s	\No1
 move.w	d0,F_Mx(a5)
 neg.w	F_Mx(a5)
\No1:
 btst.b	#Right_Key,d5
 bne.s	\No2
 move.w	d0,F_Mx(a5)
\No2:
 btst.b	#Up_Key,d5
 bne.s	\No3
 move.w	d0,F_My(a5)
 neg.w	F_My(a5)
\No3:
 btst.b	#Down_Key,d5
 bne.s	\No4
 move.w	d0,F_My(a5)
\No4:
 move.w	#18,F_Action(a5)
\NoBoule:

 cmp.w	#BOUBOULE_MAX,BouBoule
 beq.s	\NoRestore
 cmp.w	#18,F_Action(a5)
 beq.s	\NoRestore
 addq.w	#1,BouBoule
\NoRestore:

 move.w   F_Action(a5),d0
 move.w   Action_Code_Table(pc,d0.w),d0     
 jsr      Action_Code_Table(pc,d0.w)

 bsr	Limites
 jsr	fer3c::ReadOption
 
 move.w d6,Xj(a5)
 move.w d7,Yj(a5)

 moveq	#0,d2
 move.w	d6,d0
 move.w	d7,d1
 move.w	Dessin(a5),d2
 add.w	F_Sens(a5),d2

 bsr	PutSprite

; Print the shield
 move.w fer3c::Inv,d2
 beq.s	\Escape
 subq.w #1,d2
 move.w d2,fer3c::Inv
 moveq	#BULLE,d2
 bsr	PutSprite
\Escape:

; Test bouboule
 move.w	BouBoule(PC),d2
 beq	\No
 move.w	#1,fer3c::Inv
\No:

; Mise  jour des coordonnes du scrolling
 jsr	fer3c::UpDateScrollVar

; Next Sprite
 lea	F_End(a5),a5
 rts

Action_Code_Table:
	dc.w Tombe-Action_Code_Table		; 0
	dc.w Marche-Action_Code_Table		; 2
	dc.w Saut-Action_Code_Table		; 4
	dc.w Bumper-Action_Code_Table		; 6
	dc.w Propulseur-Action_Code_Table	; 8
	dc.w Special_Saut-Action_Code_Table	; 10
	dc.w Accroche-Action_Code_Table		; 12
	dc.w PasseurAct-Action_Code_Table	; 14
	dc.w Fly-Action_Code_Table		; 16
	dc.w GoBouBoule-Action_Code_Table	; 18

Special_Saut:
 move.w #SPECIAL_SAUT,Dessin(a5)
 bra.s	SautRoutine

Saut:
 move.w #SAUT,Dessin(a5)
SautRoutine:
 move.w	F_St(a5),d2
 blt.s	Sau2
 and.w	#15,d2
 bne.s	SautEntry
 Jump_Key_Test
 beq.s	SautEntry
 clr.w	F_St(a5)
SautEntry:
 move.w	F_Speed(a5),d2
 sub.w	d2,F_St(a5)
 move.w	d6,d0
 move.w	d7,d1
 sub.w	d2,d1
 jsr	fer3c::GetTest
 beq.s	Sau2
 move.w	d1,d7
SautEnd:
 rts
Sau2:
 clr.w F_Action(a5)
 rts

Tombe:
 move.w d6,d0
 move.w d7,d1
 add.w	MyTurbo(PC),d1
 jsr	fer3c::GetTest
 beq.s  Marche
\TombeL1:
 move.w d1,d7
 move.w #TOMBE,Dessin(a5)
 rts

Marche:
 Jump_Key_Test
 bne.s Mar1
 move.w F_Haut(a5),d2
 move.w d2,F_St(a5)
 move.w #4,F_Action(a5)
 bra  SautEntry

Mar1:
 cmpi.b #255,d5
 bne.s  Mar2
 tst.b	F_BWait(a5)
 beq.s  PasseTemps
 addq.b #1,F_BWait(a5)
 move.w #DEBOUT,Dessin(a5)
 rts

Mar2:
 move.b #1,F_BWait(a5)
 move.w #MARCHE,Dessin(a5)
MarcheEntry:
 move.w  F_Phase(a5),d0
 addq.w  #1,d0
 andi.w  #31,d0
 move.w  d0,F_Phase(a5)
 andi.w  #24,d0
 lsr.w   #2,d0
 add.w   d0,Dessin(a5)
 rts

PasseTemps:
 move.w #PASSE_TEMPS,Dessin(a5)
 bra.s	MarcheEntry

Bumper:
 move.w F_St(a5),d2
 blt	Sau2
 move.w #BUMPER,Dessin(a5)
 bsr    MarcheEntry
 bra    SautEntry

Propulseur:
 move.w F_Mx(a5),d0
 bne	PropSuite
 tst.w	F_My(a5)
 beq	ThatsAll
PropSuite:
 add.w  d6,d0
 move.w d7,d1
 clr.w  F_Sens(a5)
 jsr	fer3c::GetTest
 beq    ThatsAll
 move.w d0,d6
 add.w  F_My(a5),d1
 jsr	fer3c::GetTest
 beq    ThatsAll
 move.w d1,d7
 rts

ThatsAll:
 clr.l  F_Mx(a5)
 bra    Sau2 

Accroche:
 move.w #ACCROCHE,Dessin(a5)
 btst.b #Right_Key,d5
 beq    \Exit0
 btst.b #Left_Key,d5
 bne    Accroche_Exit1
\Exit0:
 bsr    MarcheEntry
Accroche_Exit1:
 Jump_Key_Test
 bne    \Exit2
 move.w F_Haut(a5),d0
 move.w d0,F_St(a5)
 move.w #4,F_Action(a5)
 rts
\Exit2:
 clr.w  F_Action(a5)
 rts

PasseurAct:
 move.w  #PASSEUR,Dessin(a5)

 move.w fer3c::Time,d1
 lsr.w  #4,d1
 andi.w #31,d1
 and.w  #$FFE0,d7
 cmpi.w #16,d1
 bls	\Nothing
 add.w  #32,d7
 neg.w  d1
\Nothing:
 add.w  d1,d7
 bra	Accroche_Exit1

Fly:
; Explosion ?
 move.w  fer3c::Time,d0
 andi.w  #127,d0
 bne	\skip
 moveq #10,d0
 move.w  d6,d1
 move.w  d7,d2
 jsr	fer3c::SpriteInit
\skip:
 move.W d6,d0
 move.w d7,d1
 move.w #FLY,Dessin(a5)

; Up ?
 btst.b #Up_Key,d5
 bne    \NoDown

 move.w #FLY_UP,Dessin(a5)
 sub.w  F_Speed(a5),d1
 jsr    fer3c::GetTest
 beq    SuiteAct2
 move.w d1,d7
 rts

; Down ?
\NoDown:
 btst.b #Down_Key,d5
 bne    SuiteAct2
 move.w #FLY_DOWN,Dessin(a5)
 add.w  F_Speed(a5),d1
 jsr    fer3c::GetTest
 beq    SuiteAct2
 move.w d1,d7
SuiteAct2:
 rts

GoBouBoule:
 move.w F_Mx(a5),d0
 bne	\Suite
 tst.w	F_My(a5)
 beq	ThatisAll
\Suite:
 add.w  d6,d0
 move.w d7,d1
 clr.w	F_Sens(a5)
 jsr	fer3c::GetTest
 beq    ThatisAll
 move.w d0,d6
 add.w  F_My(a5),d1
 jsr	fer3c::GetTest
 beq    ThatisAll
 move.w d1,d7
 subq.w	#BOUBOULE_RECUP,BouBoule
 ble	ThatisAll
 move.w #PASSE_TEMPS+1,Dessin(a5)
 bra    MarcheEntry

ThatisAll:
 clr.l  F_Mx(a5)
 clr.w	BouBoule
 bra    Sau2 


Limites:
; Test sortie Gauche/Droite
 move.w	d6,d0
 cmpi.w #4080,d0	; 32 * tailleX - TaillXFer
 bls    Suitegd
 clr.w  F_Mx(a5)	; Stop X-propulsor 
 clr.w  d6		; X = 0
 cmpi.w #10000,d0
 bhi    Suitegd
 move.w #4080,d6	; X = 4080
Suitegd:

; Test sortie Haut/Bas
 cmpi.w	#1004,d7
 bls	Suitehb
 cmpi.w	#2000,d7
 bhi	SortieHaut
 clr.b	fer3c::Statut		; You die !
SortieHaut:
 clr.w	F_My(a5)	; Stop Up-propulsor
 clr.w	d7		; Y=0
Suitehb:
 rts

Sprite_L_Head:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	addq.w	#1,d1		; Y = Y + 1
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	\Escape		; No
	move.w	d1,Yj(a5)	; Yes, save the Y coordinate
\Escape:
	subq.w	#1,L_Wait(a5)
	bne	\Ok
	neg.w	L_Vx(a5)
	moveq	#50,d0
	jsr	flib::random
	add.w	#60,d0
	move.w	d0,L_Wait(a5)
\Ok:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   L_Vx(a5),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	\Conti		; No, skip
	cmp.w   #4080,d0	; Border of the screen ?
	bhi	\Conti
	move.w  d0,Xj(a5)	; Save X
	bra	\Conti2
\Conti:	
	neg.w	L_Vx(a5)	; The sprite can't go here : Vx = -Vx
\Conti2:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne	\No		; No, skip
	cmp.w	Yj(a5),d7	; Yfernando > Y ?
	blt	Destroy		; Yes, so we will destroy the sprite
	jsr	fer3c::Hurt	; ...
\No:	
	jsr	fer3c::TestExitScreen
	bne	Next
	move.l  fer3c::LevelTestADR,a0
	move.w  Adress(a5),d0
	move.b	#NUMBER,0(a0,d0.w)	; Restore NUMBER in TestTable
	move.w	Gfx(a5),d1
	move.l	fer3c::LevelADR,a0
	move.b	d1,0(a0,d0.w)		; Restore the sub-sprite
	moveq	#L_End,d0
	jmp	fer3c::DestroySprite
Destroy:
	moveq	#6,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1
	move.l  fer3c::SpriteADR,a0	; Get the beginining of the buffer
					; fernando is the 1st sprite.
	move.w  F_Haut(a0),d0		; Get the MaxJump that Fernando can do
	move.w  d0,F_St(a0)		; Save it
	move.w  #10,F_Action(a0)	; Init Jump2
	moveq  #L_End,d0		; Get the size of the sprite
	jmp	fer3c::DestroySprite	; Quit and destroy the sprite
Next:
	moveq	#0,d2
	move.w	L_A(a5),d2
	addq.w	#1,d2
	and.w	#31,d2
	move.w	d2,L_A(a5)
	lsr.w	#4,d2
	add.w	#LITTLE_HEAD,d2
	tst.w	L_Vx(a5)
	bgt	\Ok
	addq.w	#2,d2
\Ok:
	move.w	Xj(a5),d0	; D0 = X
	move.w	Yj(a5),d1	; D1 = Y
	bsr	PutSprite	; put the sprite
	lea	L_End(a5),a5	; Next Sprite
	rts			; Return

Sprite_Thief:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	add.w	T_Vy(a5),d1		; Y = Y + 1
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	\CanJump		; No
	move.w	d1,Yj(a5)	; Yes, save the Y coordinate
	bra	\Escape
\CanJump:
	tst.w	T_Vy(a5)
	blt	\Escape
	moveq	#50,d0
	jsr	flib::random
	add.w	#60,d0
	move.w	d0,T_Wait(a5)
	neg.w	T_Vy(a5)
\Escape:
	subq.w	#1,T_Wait(a5)
	bne	\Ok
	neg.w	T_Vy(a5)
\Ok:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   T_Vx(a5),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	\Conti		; No, skip
	cmp.w   #4080,d0	; Border of the screen ?
	bhi	\Conti
	move.w  d0,Xj(a5)	; Save X
	bra	\Conti2
\Conti:	
	neg.w	T_Vx(a5)	; The sprite can't go here : Vx = -Vx
\Conti2:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne	\No		; No, skip
	cmp.w	Yj(a5),d7	; Yfernando > Y ?
	blt	DestroyT		; Yes, so we will destroy the sprite
	jsr	fer3c::Hurt	; ...
\No:	
	jsr	fer3c::TestExitScreen
	bne	NextT
	move.l  fer3c::LevelTestADR,a0
	move.w  Adress(a5),d0
	move.b	#NUMBER,0(a0,d0.w)	; Restore NUMBER in TestTable
	move.w	Gfx(a5),d1
	move.l	fer3c::LevelADR,a0
	move.b	d1,0(a0,d0.w)		; Restore the sub-sprite
	moveq	#T_End,d0
	jmp	fer3c::DestroySprite
DestroyT:
	moveq	#6,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1
	move.l  fer3c::SpriteADR,a0	; Get the beginining of the buffer
					; fernando is the 1st sprite.
	move.w  F_Haut(a0),d0		; Get the MaxJump that Fernando can do
	move.w  d0,F_St(a0)		; Save it
	move.w  #10,F_Action(a0)	; Init Jump2
	moveq  #T_End,d0		; Get the size of the sprite
	jmp	fer3c::DestroySprite	; Quit and destroy the sprite
NextT:
	moveq	#0,d2
	move.w	T_A(a5),d2
	addq.w	#1,d2
	and.w	#63,d2
	move.w	d2,T_A(a5)
	lsr.w	#4,d2
	add.w	#THIEF,d2

	move.w	Xj(a5),d0	; D0 = X
	move.w	Yj(a5),d1	; D1 = Y
	bsr	PutSprite	; put the sprite
	lea	T_End(a5),a5	; Next Sprite
	rts			; Return

Sprite_Missile:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	move.w	Gfx(a5),d3
	subq.w	#3,d3
	lsl.w	#2,d3
	add.w	(Missile_Table+2)(PC,d3.w),d1		; Y = Y + 1
	add.w   (Missile_Table)(PC,d3.w),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	DestroyMissile		; No
\Ok:
	move.w	d1,Yj(a5)
	move.w  d0,Xj(a5)	; Save X

	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne	\No		; No, skip
	jsr	fer3c::Hurt	; ...
\No:	
	jsr	fer3c::TestExitScreen
	bne	NextM
DestroyMissile:
	move.w	d1,d2		; Y
	move.w	d0,d1		; X
	moveq	#INIT_ADDON,d0	; Add-On sprite
	move.l	fer3c::LevelADR,a0	; Get the adress of the table of gfx
	move.b	#7,(a0)		; point sprite
	clr.w	d3		; Adress : we change the adress 0
				; WARNING : Do not work with multi plan.
	jsr	fer3c::SpriteInit	; Init the sprite
	moveq	#M_End,d0
	jmp	fer3c::DestroySprite
NextM:
	moveq	#0,d2
	move.w	Gfx(a5),d2
	add.w	#(M_UP-3),d2
	bsr	PutSprite	; put the sprite
	lea	M_End(a5),a5	; Next Sprite
	rts			; Return

Missile_Table:
	dc.w	0,-2
	dc.w	-2,0
	dc.w	0,2
	dc.w	2,0
	
Sprite_Point:
	move.w	Xj(a5),d0	; d0 = X coordinate
	move.w	Yj(a5),d1	; d1 = Y coordinate
	add.w	P_Vy(a5),d1		; Y = Y + 1
	add.w   P_Vx(a5),d0	; X = X + Aux_Vx
	move.w	d1,Yj(a5)	; Save y
	move.w  d0,Xj(a5)	; Save X

	jsr	fer3c::TestExitScreen
	bne	NextP
	moveq	#P_End,d0
	jmp	fer3c::DestroySprite
NextP:
	moveq	#EXP,d2
	bsr	PutSprite	; put the sprite
	lea	P_End(a5),a5	; Next Sprite
	rts			; Return

Sprite_Hedg:
	; Fire ?
	subq.w	#1,H_Fire(a5)
	bne	\NoFire
	move.w	Xj(a5),d1	; X
	move.w	Yj(a5),d2	; Y
	move.w	d1,d0
	sub.w	d6,d0
	bsr	Signe
	move.w	d0,d4		; Vx
	move.w	d2,d0
	sub.w	d7,d0
	bsr	Signe
	move.w	d0,d5		;Vy
	moveq	#4,d0		; Sprite laser
	jsr	fer3c::SpriteInit
	moveq	#127,d0
	jsr	flib::random
	move.w	d0,H_Fire(a5)
\NoFire:
	; Gestion Y
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1

	move.w	H_Act(a5),d2
	beq	H_Fall
	cmp.w	#1,d2
	beq	H_Jump
H_Walk:
	move.w  H_A(a5),d2
	addq.w  #1,d2
	andi.w  #31,d2
	move.w  d2,H_A(a5)
	andi.w  #24,d2
	lsr.w   #2,d2
	add.w	#HEDG,d2
	move.w	d2,Dessin(a5)
	
	subq.w	#1,H_WAct(a5)
	beq	NewJump

	addq.w	#2,d1
	jsr	fer3c::GetTest
	beq	GestX
NewFall:
	clr.w	H_Act(a5)
H_Fall:
	move.w	#HEDG_DOWN,Dessin(a5)
	addq.w	#2,d1
	jsr	fer3c::GetTest
	beq	NewWalk
	move.w	d1,Yj(a5)
	bra	GestX
NewWalk:
	MOVE.w	d0,-(a7)
	moveq	#100,d0
	jsr	flib::random
	add.w	#10,d0
	move.w	d0,H_WAct(a5)
	move.w	#2,H_Act(a5)
	MOVE.w	(a7)+,d0
	bra	H_Walk

NewJump:
	MOVE.w	d0,-(a7)
	moveq	#50,d0
	jsr	flib::random
	add.w	#10,d0
	move.w	d0,H_WAct(a5)
	move.w	#1,H_Act(a5)
	MOVE.w	(a7)+,d0
H_Jump:
	move.w	#HEDG_UP,Dessin(a5)

	subq.w	#1,H_WAct(a5)
	beq	NewFall

	subq.w	#2,d1
	jsr	fer3c::GetTest
	beq	NewFall
	move.w	d1,Yj(a5)
	bra	GestX


	; Gestion X
GestX:
	subq.w	#1,H_Wait(a5)
	bne	\Ok
	neg.w	H_Vx(a5)
	moveq	#50,d0
	jsr	flib::random
	add.w	#60,d0
	move.w	d0,H_Wait(a5)
\Ok:
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	add.w   H_Vx(a5),d0	; X = X + Aux_Vx
	jsr	fer3c::GetTest	; Can it be possible ?
	beq	\Conti		; No, skip
	cmp.w   #4080,d0	; Border of the screen ?
	bhi	\Conti
	move.w  d0,Xj(a5)	; Save X
	bra	\Conti2
\Conti:	
	neg.w	H_Vx(a5)	; The sprite can't go here : Vx = -Vx
\Conti2:

	; Collision avec BOB ?
	move.w  Xj(a5),d0
	move.w  Yj(a5),d1
	jsr	fer3c::TestCollision	; Sprite and Fernando ?
	bne	\No		; No, skip
	cmp.w	Yj(a5),d7	; Yfernando > Y ?
	blt	DestroyH		; Yes, so we will destroy the sprite
	jsr	fer3c::Hurt	; ...
\No:	
	jsr	fer3c::TestExitScreen
	bne	NextH
	move.l  fer3c::LevelTestADR,a0
	move.w  Adress(a5),d0
	move.b	#NUMBER,0(a0,d0.w)	; Restore NUMBER in TestTable
	move.w	Gfx(a5),d1
	move.l	fer3c::LevelADR,a0
	move.b	d1,0(a0,d0.w)		; Restore the sub-sprite
	moveq	#H_End,d0
	jmp	fer3c::DestroySprite
DestroyH:
	move.w	fer3c::Time,d2
	andi.w	#3,d2
	bne	\No2Explosion

	; 2nd Explosion
	moveq	#10,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1

\No2Explosion:
	; Jump Bob
	move.l  fer3c::SpriteADR,a0	; Get the beginining of the buffer
					; fernando is the 1st sprite.
	move.w  F_Haut(a0),d0		; Get the MaxJump that Fernando can do
	move.w  d0,F_St(a0)		; Save it
	move.w  #10,F_Action(a0)	; Init Jump2

	; Fire
	move.w	#50,H_Fire(a5)

	; Test force
	subq.w	#1,H_Invu(a5)
	bne	NextH

	; 1st Explosion
	moveq	#6,d0		; D0 = No_Sprite_Exlosion_1
	move.w  Xj(a5),d1	; D1 = X
	move.w  Yj(a5),d2	; D2 = Y
	jsr	fer3c::SpriteInit	; Init explosion 1
	; Kill the sprite
	moveq  #H_End,d0		; Get the size of the sprite
	jmp	fer3c::DestroySprite	; Quit and destroy the sprite
NextH:
	moveq	#0,d2
	move.w	Dessin(a5),d2
	tst.w	H_Vx(a5)
	bgt	\Ok
	addq.w	#1,d2
\Ok:
	move.w	Xj(a5),d0	; D0 = X
	move.w	Yj(a5),d1	; D1 = Y
	bsr	PutSprite	; put the sprite
	lea	H_End(a5),a5	; Next Sprite
	rts			; Return









PutSprite:
 lsl.w	#5,d2		; 32 * D2 (A Gfx is 32 bytes long)
 lea	Graphic(PC),a0
 add.l   d2,a0		; A0 = Adress of the gfx of the sprite
 jmp	fer3c::PutSprite

; Entry d0, return 1 if d0>0, -1 if d0<0 and 0 if d0=0
Signe:
 tst.w	d0
 blt	\E1
 beq	\E0
 moveq	#-1,d0
\E0
 rts
\E1:
 moveq	#1,d0
 rts

Graphic:	INCBIN	"bob.s16"
		INCBIN	"EnmBob.s16"

BouBoule	dc.w	0
MyTurbo		dc.w	0

; You don't need _main, _comment, end because it will be added to the world
; thanks to MkWorld. (This file is an include file).
